          SECTION E                                                FILE MORE.E
                      A SUMMARY OF ERROR MESSAGES IN MALLARD BASIC
                      ********************************************

          MALLARD BASIC provides a number of messages to help diagnose faults
          in a program or problems which arise whilst running a program. The
          following is a list of these messages with brief explanations where
          needed.The reference number is also the error number returned by
          BASIC.

          GENERAL
          =======

          1  Unexpected NEXT
              A NEXT command has been found without a valid FOR loop. If the
          loop is in place check the variable.

          2  Syntax Error

          3  Unexpected RETURN
              A RETURN command has been found when not in a subroutine.

          4  DATA exhausted
              There is not enough DATA to match the READ statement

          5  Improper argument
              General purpose error. A command is invalid in some way. If the
          error message is given whilst READing in an array, check whether an
          item of data is invalid in some way.

          6  Overflow
              Arithmetical operation has failed, maybe because a number
          generated is too large. Try splitting the operation up.

          7  Memory full
              Check the program size (about 28K max) or maybe the stack is too
          small; increase with CLEAR or MEMORY. If the message appears whilst
          editing use CLEAR or FRE("") to discard variables or garbage
          collect.

          8  Line does not exist

          9  Subscript out of range
              A subscript in an array variable is too big or too small. Can
          often be a syntax or mismatch error

          10 Array already dimensioned
              This is often a nuisance when checking a program and using GOTO
          instead of RUN to start it. You have repeated a DIM statement, which
          is illegal. Try ERASE [array base name] to cancel array and try
          again

          11  Division by zero
              Mathematics; You have attempted to divide by zero which gives
          infinity as the result, which is not allowed. Check your maths!

          12  Invalid direct command
              Command issued is not accepted in Direct Mode

          13  Type mismatch
              Usually a mix-up of variable types. If the indicated line seems
          o.k check previous usage of the variable.

          14  String space full
              The memory reserved for strings is full even after garbage
          collection.

          15  String too long
              Max length of string is 255 characters. Maybe you have exceeded
          this unwittingly by adding strings together?

          16  String expression too complex
              You've got a complicated mind and BASIC has given up on you!

          17  Cannot CONTinue
              After a STOP command the program has been altered before
          attempting to use CONT

          18  Unknown user function
              BASIC is denying that you defined the DEF FN that you are trying
          to use. Check that you are running the DEF FN line. DEF FN does not
          seem to survive a CHAINing manoevre, whatever you do.

          19  RESUME missing.
              Check your error-trapping routine. ON ERROR GOTO

          20  Unexpected RESUME
              Check your error-trapping routine. ON ERROR GOTO

          21  O/S dependent error
              Operating system error; Use OSERR to specify error further

          22  Operand missing
              Incomplete expression

          23  Line too long
              Seems obvious and usually is, but can sometimes be a mystery

          26  NEXT missing
              a FOR command with no NEXT. Forgot it? I often do.

          29  WEND missing
              A WHILE command with no WEND

          30  Unexpected WEND
              Check your WHILE loop

          DISC AND FILE ERRORS
          ====================

          50  Record overflow
              Not enough space in memory for records in Random or Jetsam
          files. Check for discrepancies in space allocation

          51  Internal error
              Software or hardware problem.

          52  File number error
              You have specified the wrong file number .Check

          53  File not found

          54  File type error

          55  File already open

          57  Disc I/O error
              Input / output error.

          58  File already exists
              You have tried to rename a file with a name already in use on
          the disc .Can occur using NAME, REN or CREATE

          61  Disc full

          62  EOF met
              You tried to read past the End Of File marker (sequential file)

          63  Record number error
              File record number you specified is wrong

          64  File name invalid
              Check on the rules for inventing a file name

          66  Direct command found
              File is not in suitable form for loading

          67  Directory full
              Directory space is limited to 64 entries in standard format

          68  Read past EOF
              File handling

          69  Record is locked
              File handling error when trying to use GET or PUT incorrectly

          70  Read-only disc
              Disc is write-protected

          71  Read-only file
              File is write-protected

          72  Invalid drive

          73  File is locked

          74  RESET denied


          JETSAM ERRORS
          =============

          113  Not a keyed file
               JETSAM does not recognise a file it has been instructed to OPEN

          114  Record is not locked
               Incorrect use of GET or PUT

          115  Inconsistent files
               Data and index files are inconsistent and therefore unusable.
          This error occurs only too frequently, usually through operator
          error. Make regular back-up files whilst entering data .


          COMMENT
          =======

          Whilst the above list may seem formidable, only a few are seen
          frequently, many others are seen rarely and others you will probably
          never see.

          End of file MORE.E
   frequently, many others are seen rarely and others you wi