          SECTION G                                                FILE MORE.G
                              USING THE PRINTER from BASIC
                              ****************************

          In the file INTER I we looked at many ways of modifying the printer
          output; changing typestyles, varying margins and spacing of rows
          etc., but rather glossed over ways of printing out information from
          within the BASIC environment. In this file I shall remedy this
          omission.

          To start with, let's recap on methods mentioned previously.

          Remember how in printing from CP/M anything appearing on the screen
          can be echoed on the printer by toggling [ALT] and letter [P]. This
          won't work in the BASIC environment, but the same thing is achieved
          by the command  POKE 8792,205 and the antidote is POKE 8792,195.
          Copy the following short program to check this out.

              90 INPUT "Do you want screen output also to printer? y/n ",c$
              100 IF c$="n" THEN 120
              110 poke 8792,205
              120 input "What is your name",  name$
              130 print "Have a nice day " name$
              140 poke 8792,195
              150 print "This sentence will not be echoed to printer"

          This may be all that is needed for some programs, and it can be
          arranged to jump over line 110 if no printer echo is wanted as shown
          in lines 90 and 100 above. Note that this short listing is not an
          example of good programming, but is just for demonstration.

          To print out a program listing, use LLIST; e.g
              LLIST  lists out the whole program
              LLIST  - 1000 lists the program as far as line 2000
              LLIST  200-500 lists lines as shown
              LLIST  350- lists lines from 350 onwards.

          To print out a number, variable, or string use LPRINT, using the
          same rules as PRINT e.g

              LPRINT  "Hello World"
              LPRINT  name$
              LPRINT  120
              LPRINT  z

          If all you need is an output from the line printer this could be a
          good solution; write your program using PRINT commands to test it,
          then replace these by LPRINT. Alternatively you could write two
          identical modules, one with PRINT, the other with LPRINT and then
          select one ot the other (or both) by a simple menu.

          Using a temporary file   However, in some programs, none of these
          ======================   solutions fit in, or they may prove to be
          too cumbersome. The solution here is to make a temporary file which
          can then be displayed on screen or printed out as required. The
          procedure for writing the program is as follows.

              1) Write the program storing all relevant detail in variables.
              Offer a choice of printing to screen or to printer.

              2) Open a temporary sequential file using the command
                      OPEN "o",1,"temp.$$$"

              3) Write to the file exactly as you would to get a display on
              the screen, but in place of PRINT, use PRINT #1 -for example
                      PRINT #1 " Your name is " name1$
                      Print #1 " You have scored " p "points
                      IF p > q THEN PRINT #1 " Your score is the best so far"

              4) Close the file with the command:-
                      CLOSE 1

              5) Reopen the file with the command:-
                      OPEN "i",1,"temp.$$$

              6) Recover the file a line at a time with the command :-
                      LINE INPUT #1 line$ ,  using a loop.

              7) Display the file on screen using PRINT, or to the printer
              using LPRINT, as requested in 1) above.

          Following this text file is a piece of code showing how the above
          might be achieved in practice. It asks you to input your name,
          address, telephone number etc., and makes a file using the
          information given. You are then offered a choice of output to screen
          or printer. After trying the various options, LLIST the code on the
          printer (lines 9100 to 9870 of MORE.BAS) and compare it with the
          general instructions above. Unfortunately you will probably find
          that the # symbol will print out as , but this has to be lived
          with. Note that the code relevant to present discussion is contained
          in lines 9510 to 9590, 9700 to 9760 and 9800 to 9860.  The rest has
          already been covered, but a few notes may not come amiss.

          9300/9310   A simple way to pause whilst reading the notes.
          9320        Clear screen; cls$ was defined in line 10 of TUTOR.BAS
          9350/9400   Any means of gathering information can be used. Here I
                      use LINE INPUT.
          9510        OPEN "o" opens file to gather "o"utput from source, in
                      this case the keyboard.  '1' is the file reference
                      number; 3 files can be opened at any one time, or more
                      if specified by MEMORY or CLEAR. After opening, the file
                      must be referred to by it's ref.number. Temp.$$$ is the
                      file name, $$$ being the preferred tail for a temporary
                      file. Note that I have called for it to be installed on
                      the m: drive for a variety of reasons;
                          1) Your disc might be write-protected.
                          2) When the machine is turned off the file will be
                          lost, so you won't have to delete it.
                          3) Saves disc space.
          9590        CLOSE 1; Very necessary.
          9600/9670   Various options for user to exercise.
          9700/9760   Module which opens file to provide "i"nput to screen
          9800/9860   Similar module to provide "i"nput to printer.
          9870        If you remove the REM in this line, the temporary file
                      will be deleted, which is usual if the file is saved to
                      disc. I have left it so that the file remains on the M
                      drive for your inspection with the TYPE command if you
                      wish.

          Provided the steps outlined above are included, all manner of
          modifications to the program are possible, to suit requirements.
          Although I have shown one module for output to screen, and another
          for output to printer for clarity, the two modules could be combined
          into one, perhaps using a GOSUB routine to separate the PRINT and
          LPRINT options.  The same principle could be used to make a
          permanent file if required.

          End of file MORE.G



ons.  The same principle could be used to make a
          permanent file if required.

   