          SECTION H                                                FILE MORE.H
                                 Understanding Programs
                                 **********************

          In order to improve your knowledge of BASIC you should try to
          decipher programs with which you come into contact. Not only will
          you learn how to program but you will also learn how not to program.
          Some programmers simply keep writing code with no planning
          whatsoever and finish up with what is disparagingly called spaghetti
          code, jumping all over the place and making it very difficult to
          follow. Good programmers write programs in planned, labelled,
          modules. These are the best programs to study and learn from

          Sometimes you may see a layout on screen that you like, or maybe you
          want to know how to duplicate a particular effect. In cases like
          this you will only need to find the particular piece of code and
          study it, but for present purposes let us consider how best to
          dissect a complete program.

          Something that you will often have to do is to search for keywords,
          track variables and isolate subroutines. This can be time-consuming,
          frustrating and hard on the eyes, so I have included on Side 4 a
          utility called FIND.COM, which will take the hard work out of this
          chore. Briefly, FIND.COM will find any specified string of
          characters in a file and display any lines in which the string is
          found. In MALLARD BASIC this will also include the line number,
          which is helpful. A qualification is that the file must have been
          saved in ASCII format. The file EXTRA.F describes in detail how to
          use FIND.COM.

          It's best to start with a program which is already committed to
          disc, is free of bugs, and is not protected. Run the program and
          play with it for a while, so as to get the general idea of what it
          does, how it is displayed on the screen and so on, then LLIST it to
          get a hard copy to study. If necessary, resave it in ASCII format
          for use with FIND.COM  with the command       SAVE "program ",a

          Deciphering a program can be made easier if it is done in an orderly
          fashion, and so I suggest that the following steps be followed, not
          necessarily in the order in which they are given, nor need a step be
          completed before going on to another. It is a little like doing a
          jigsaw puzzle, or a crossword, where each part completed assists in
          the adjacent parts.

          1)  Load and run the program, to familiarise yourself with what it
              does, how it looks on screen and so on.

          2)  Print off a hard copy of the listing on the printer, using the
              command LLIST

          3)  Read through the listing to get a general feel for the program.
              Are modules or subroutines named in REM statements?, are there
          other useful REM statements?,(don't forget that ' may have been used
          instead of REM), are there DATA lines, implying arrays, and if so,
          what type are they. (FOR...NEXT loops of POKEs may denote machine
          code). Look for OPEN and CLOSE to see if files are used. These and
          many other signs are immediately helpful to an understanding of the
          program structure.

          4)  Do a 'trail' of the program to find it's sequence of operation
              and make a chart, labelling program parts.This is most easily
          done by inspection of the listing after finding all lines containing
          'GOTOs' and 'GOSUBs' with FIND.COM. You must also check all
          instances of 'THENs' from the IF...THEN statements where GOTO might
          be understood. This trail can be recorded on paper, using a method
          of your own devising. I use something like this :-

          10- 90 Initialisation
          100- 300 Menu
          310- 400 Choice of menu (nos 1 to 6)
          410------------> Sub/r; 2000-2500 choose a number
          420------------> Module no 1; 3000-3700 ...?
          420------------> Module no 2; 4000-4900 ...?
          420------------> Module no 3; 4000-4900 ...?
          420------------> Module no 4; 4000-4900 ...?
          430- 500 Mugtraps for menu/ return to CP/M

          Fill in as much as possible, leaving blanks as necessary, then
          return later, when more is known, to fill in the blanks; it's quite
          a painstaking job but well worth doing as you're learning all the
          time. If it helps, draw a line representing the passage of the
          program, showing modules and subroutines as labelled boxes and
          indicating how they are joined to the main program stem with arrows
          denoting direction. By this time you should be feeling some
          familiarity with the program and beginning to understand how the
          program hangs together to produce what you have observed on screen,
          but from your point of view the most important questions are still
          to be answered; how does the code for each module, subroutine or
          other lines work ?.

          5)  Make a list of all variables and trace them one at a time with
              FIND.COM, to find where they were first used and what part each
          variable plays. The same variable may appear several times in
          FOR...NEXT loops e.g  FOR i=1 to 10 and in this case they are
          probably local and not of consequence outside the loop. Others may
          be obviously connected such as nm1$, nm2$ and could, for example,
          represent names of players 1,2,3 etc. as entered in an INPUT
          statement. Other variables may look similar and connected, e.g  a$
          and a. In this case a$ may be the number in 'a', but converted to a
          string for manipulation, or a may be the numerical equivalent of a$.
          However don't be fooled by a symbol after a numeric variable; for
          example a% and a are nominally the same. If you are puzzled by a
          variable in a WHILE...WEND loop that appears only once it is
          probably a trick use of logic, so for WHILE NOT bored , read WHILE
          NOT 0. (Undefined variables are given the default value 0, and 0 is
          treated as 'false' in logic, any other value as true ) so WHILE NOT
          bored means 'while not false', thus the WHILE loop will operate
          until a false statement is made.
 
          6)  Take each unit of the program and dissect it until you are sure
              that you understand it perfectly. Don't be afraid to make notes
          on your printed listing, and don't be intimidated by complex
          statements. Many bits of code which seem complicated, particularly
          where multiple brackets are used) will yield to determination. If
          not, keep returning to it until it does.

          Decoding Aids    Many of the methods which can be used for decoding
          *************    programs are the same as those for debugging, so
          have another look at the file MORE.D; I shall only outline them
          here.
              TRON (TRace ON) is used at the BASIC prompt to trace line
          numbers. Use it to determine the order in which lines are processed.
          If necessary use REM or STOP inside the listing to assist.
              Programs can be run from any line number with RUN or GOTO. RUN
          cancels all existing values of variables, GOTO preserves them. If an
          array has been declared and you use GOTO you will get the message
          "Array already dimensioned" If the array is, for example b$(10),
          then using the command ERASE b$ will cure this.

          Remember that when STOP is pressed or a stop is encountered in the
          program listing all variables retain their current value in memory,
          and this can be used to trace values of variables at various points
          in the program. Strategic placings of STOP commands or careful use
          of the [STOP] key and inspection of variables can yield valuable
          information. Use the PRINT command at the prompt to find the
          value(s) of variables at a given time; e.g PRINT n will give the
          current value of numeric variable 'n'.

          Temporarily cancelling a line or lines with REM, giving a variable a
          different value, or otherwise changing the program in some way can
          often give clues to what a particular line or section does, but only
          alter one thing at a time. As long as you don't SAVE your version
          the original on disc won't change, of course, but if it's your only
          copy either write-protect the disc or make a copy and work from
          that.  This is only good practice.

          At the start of this file I mentioned decoding only part of a
          program, and as you become more proficient this is probably all you
          will need to do.  You will be able to read and understand a listing
          except maybe for one part which is obscure. In such circumstance
          there is obviously no need to do a complete trail. It helps, though,
          if you can identify what the section does, and it's significance.

          FIND.COM can be used to locate sections of code too. For example, if
          a program has a menu option to return to CP/M, ask FIND.COM to look
          for the keyword SYSTEM;  again, finding CHR$(27) will often reveal
          the position of the initialising section, and so on.

          A practical example   On side 4 there are two files CAMEL.BAS and
          ===================   DESERT.BAS.  CAMEL is a classic game from way
          back. I copied it from an old magazine. It is written in Microsoft
          BASIC (MBASIC) from which MALLARD was derived (MBASIC programs will
          run under MALLARD). Play it; it's good fun! then list it to see a
          prime example of spaghetti programming. I did my best to decode it
          using the principles discussed above and then rewrote it using the
          more advanced features of MALLARD BASIC and modular programming
          saving it as DESERT.BAS.  Try it yourself- the way CAMEL meanders
          and backtracks makes the listing very difficult to follow.  See if
          you can do better than I have.

          CONCLUSION   Checking how other folks write their programs is an
          ==========   essential part of learning any computer language. Make
          notes of any bits of code that interest you with a view to using
          them in your own programs, but don't try to copy anyone else's
          style; you will find it easier and more rewarding to develop your
          own.

          Sooner or later you will find advanced programs that use coding that
          is unfamiliar to you.   MALLARD BASIC supports three types of file
          systems, SEQUENTIAL, RANDOM ACCESS, and KEYED (Jetsam) , and it can
          also use MACHINE CODE. The latter is often used for graphics, which
          is not directly supported by MALLARD BASIC, so if the program that
          you are looking at has animated graphics you will probably find sub-
          programs of machine code translated into BASIC and written largely
          in DATA lines.  You can accept these for the moment once you are
          satisfied what they do, but I hope that you will resolve to add
          these specialised subjects to your repertoire in due course.

          End of file MORE.H
u will resolve to add
          these specialised subjects to your repert